
Ox.ItfBox = function(options, self) {
  var self = self || {};
  var that = new Ox.Element(options, self)
    .defaults({
      'title': '',
      'extraButtons': []
    })
    .options(options);
  var title = self.options.title; 
  var $titlebar = new Ox.Bar({
          orientation: 'horizontal',
          size: 18
      })
//      .dblclick(dblclickTitlebar)
      .appendTo(that);


  var $title = new Ox.Element()
      .addClass('OxTitle')
      .html(title/*.toUpperCase()*/)
      .appendTo($titlebar);


  var $search = new Ox.Input({
    'placeholder': 'Search',
  })
  .css({'width': '128px', 'marginLeft': 'auto', 'marginRight': 'auto'})
  .appendTo(that)
  .hide()
  .bindEvent("submit", function(value) {
    app.$ui[options.boxId].$loading.start();
    $list.options("request", function(data, callback) {
      app.$ui[options.boxId].$loading.stop();
      return app.api.find(getQueryParams(data), callback);
    });
  });


  that.search = function(word) {
    $search.options("value", word);
    $search.triggerEvent("submit");
  }

  var $buttons = new Ox.Element().appendTo($title).css({'position': 'absolute', 'top': '1px', 'right': '1px'});



  var $additionalButtons = self.options.extraButtons;
  if ($additionalButtons.length > 0) {
    $additionalButtons.appendTo($buttons);
  }

  var $maximizeBtn = new Ox.Button({
    id: options.id + "Maximize",
    style: 'symbol',
    title: 'add',
    type: 'image',
    tooltip: 'Maximize'
  }).appendTo($buttons);

  var $infoBtn = new Ox.Button({
    id: options.id + "InfoBtn",
    style: 'symbol',
    title: 'info',
    type: 'image',
    tooltip: 'More info about ' + options.title 
  })
    .appendTo($buttons)
    .bindEvent("click", function() {
      var info = options.info;
      var d = new Ox.Dialog({
        buttons: [
          new Ox.Button({
            id: 'cancel',
            title: 'Close',
            })
            .bindEvent("click", function() { d.close(); })
        ],
        content: new Ox.Element().html(info),
        title: options.title
      })
      .open();
    });

  var $searchBtn = new Ox.Button({
          id: options.id + 'SearchBtn',
          style: 'symbol',
          title: 'find',
          type: 'image',
          tooltip: 'Search'
      })      
      .bindEvent("click", function() {
        if ($search.is(":visible")) {
          $search.slideUp();
        } else {
          $search.slideDown();
          $search.focus();
        }
      })
      .appendTo($buttons);
 

  var $menuBtn = new Ox.Button({
    id: options.id + 'MenuBtn',
    style: 'symbol',
    title: 'expand',
    type: 'image',
    tooltip: 'Show Menu'
  }).appendTo($buttons);

  that.$loading = new Ox.LoadingIcon().appendTo($buttons);

  var $menu = new Ox.Menu({
    id: options.id + 'Menu',
    element: $menuBtn,
    items: [
      {
        id: 'SortBy',
        title: 'Sort By',
        items: [
          {
            'group': 'sortGroup', 
            'min': 1, 
            'max': 1,
            items: [
              {'id': 'sort_added_descending', title: 'Added (Descending)', checked: true},
              {'id': 'sort_added_ascending', title: 'Added (Ascending)'},
              {'id': 'sort_title_ascending', title: 'Title (Ascending)'},
              {'id': 'sort_title_descending', title: 'Title (Descending)'},
            ]
          }
        ]
      },
      {id: 'Test2', title: 'Menu Item 2'}
    ]
  })
  .bindEvent("change", function(e, data) {
    if (data.id === 'sortGroup') {
      var checked = data.checked[0];
      var checkedId = checked.id;
      var checkedField = checkedId.split("_")[1];
      var operator = checkedId.split("_")[2] == "ascending" ? "+" : "-";      
      $list.sortList(checkedField, operator);
    }
  });

//  var $menu = new Ox.Menu({
//    id: options.id + 'Menu',
//    element: $menuBtn,
//    items:  [
//          {
//            'group': 'sortGroup', 
//            'min': 1, 
//            'max': 1,
//            items: [
//              {'id': 'sortTitleAscending', title: 'Title (Ascending)', checked: true},
//              {'id': 'sortTitleDescending', title: 'Title (Descending)'},
//              {'id': 'sortTitleAscendingFoo', title: 'Title (Ascending)'},
//              {'id': 'sortTitleDescendingFoo', title: 'Title (Descending)'},
//            ]
//          }
//        ]
//      },
//      {id: 'Test2', title: 'Menu Item 2'}
//    ] 
//  })
//  .bindEvent("change", function() {
//    alert("foo");
//  });

//  
  
  $menuBtn.bindEvent("click", function() {
    $menu.showMenu();
  });

  function getQueryParams(data) {
//    Ox.print("SEARCHVAL", $search.val());
    return $.extend(data, {
      'search': $search.value() == 'Search' ? '' : $search.value(),
      'model': options.model,
      'module': options.module
    });
  }

  var $listContainer = new Ox.Element()
    .appendTo(that)
    .css({position: 'relative', height: '100%'});

  var listOptions = $.extend(options, {
      'width': 256,
//      'itemHeight': 16,
//      'itemWidth': 250,
//      'orientation': 'horizontal',
      'request': function(data, callback) {
        return app.api.find(getQueryParams(data), callback)
      },
      'id': options.id + 'List',
      'boxId': options.id,
      

/*
      'construct': function(data) {
        var $a = $('<a />').attr("href", "/" + options.module.toLowerCase() + "/" + data.id).text(data.title); 
        var $item = $('<div />').addClass('OxTarget').append($a);
        return $item;
      },
*/
      'max': 1,
      'columns': [
        {
          align: 'left',
          id: 'title',
          operator: '-',
          unique: false,
          visible: true,
          width: 230
        },
        {
          id: 'id',
          visible: false,
          unique: true  
        }
      ],
      'sort': [
        {
          key: 'added',
          operator: '-'
        }
      ]        
    });

  var $list = that.$list = new Ox.ItfList(listOptions)
    .appendTo($listContainer);

  return that;   
}



Ox.ItfList = function(options, self) {
  var self = self || {};
  var that = new Ox.TextList(options, self);
  that.bindEvent("select", function(e, data) {
    if (data.ids.length === 0) {
      app.$ui.previewBox.$content.html('');
      return;
    }
    app.$ui[options.boxId].$loading.start();
//    debugger;
    app.api.preview({
      model: options.model,
      module: options.module,
      id: data.ids[0]
    }, function(response) {
//      alert(JSON.stringify(response.data.data));
      app.$ui[options.boxId].$loading.stop();
//      var data = add_newlines(response['data']);
      var html = $.tmpl(response['template'], response['data']);
      app.$ui.previewBox.$content.html(html);
    }); 
  });
  that.bindEvent("open", function(e, data) {
//    alert(JSON.stringify(data));
    app.$ui[options.boxId].$loading.start();
    app.api.info({
      model: options.model,
      module: options.module,
      id: data.ids[0] 
    }, function(response) {
      app.$ui[options.boxId].$loading.stop();
      var html = $.tmpl(response['template'], response['data']);
//      alert(html);
      var d = new Ox.Dialog({
        buttons: [
          new Ox.Button({
            id: 'cancel',
            title: 'Close',
            })
            .bindEvent("click", function() { d.close(); })
        ],
        content: new Ox.Element().append(html),
        title: options.title + ": " + response.data.title,
        width: 800,
        height: 500
      })
      .open();
//      alert(response);      
    });
  });
  return that;
}

Ox.ItfCalendar = function(options, self) {
  var self = self || {};
  var that = new Ox.Element(options, self);
  var $titleBar = new Ox.Bar({
    'size': 'small'
  }).addClass('OxTitleBar').appendTo(that);
  var $title = new Ox.Element().html("Calendar").appendTo($titleBar);
  return that;
}

Ox.ItfPreview = function(options, self) {
  var self = self || {};
  var that = new Ox.Element(options, self);
  that.$content = new Ox.Element().appendTo(that);
  that.$loading = new Ox.LoadingIcon().appendTo(that);
  return that;
}

ITF.templates = {};

